=== debian/changelog ===
bro (2.4.1+dfsg-2build1) xenial; urgency=medium

  * Rebuild for glibc 2.23.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 20 Mar 2016 11:19:29 +0100

bro (2.4.1+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with OpenSSL built without SSLv3 support

 -- Hilko Bengen <bengen@debian.org>  Thu, 05 Nov 2015 18:24:43 +0100

bro (2.4.1+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Hilko Bengen <bengen@debian.org>  Thu, 29 Oct 2015 19:01:12 +0100
