=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddir=build --parallel

override_dh_clean:
	-test -r debian/broken-symlinks.tar && tar -xf debian/broken-symlinks.tar
	dh_clean

override_dh_auto_configure:
	find -L -type l | xargs -r tar -cvf debian/broken-symlinks.tar | xargs -r rm
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DBINARY_PACKAGING_MODE=true

override_dh_install:
	mkdir -p debian/tmp/etc/bro
	mv debian/tmp/usr/share/bro/site debian/tmp/etc/bro/site
	dh_install --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vmisc:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W binpac)"
