=== debian/changelog ===
bro (2.5-1) unstable; urgency=medium

  * New upstream version 2.5
  * Update watch file
  * Update patches
  * No longer strip documentation from tarball -- it has a DFSG-free
    license now.
  * Bump Standards-Version

 -- Hilko Bengen <bengen@debian.org>  Fri, 23 Dec 2016 23:36:01 +0100

bro (2.4.1+dfsg-4) unstable; urgency=medium

  * Disable OpenSSL 1.1 patches, build using libssl1.0-dev instead

 -- Hilko Bengen <bengen@debian.org>  Tue, 22 Nov 2016 09:08:22 +0100

bro (2.4.1+dfsg-3) unstable; urgency=medium

  * Port most of the OpenSSL-using code to OpenSSL 1.1 (Closes: #828254).
    OCSP validation stays disabled for now. Thanks to Sascha Steinbiss for
    his help.

 -- Hilko Bengen <bengen@debian.org>  Tue, 15 Nov 2016 12:35:28 +0100
