=== debian/control ===
--- 
+++ 
@@ -17,10 +17,10 @@
  libgoogle-perftools-dev,
  libpcap0.8-dev | libpcap-dev,
  libsqlite3-dev,
- libssl-dev,
+ libssl1.0-dev | libssl-dev (<< 1.1),
  libxml2-dev,
  zlib1g-dev,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.bro.org
 Vcs-Git: git://anonscm.debian.org/collab-maint/bro.git
 Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/bro.git;a=summary
